/* 
 HTML5视频播放器beta2（js）
 Created on : 2016-6-19, 0:56:39
 Author     : panni
 Website    : panni.me
 */
//获取视频文件DOM模型
var myVideo = document.getElementById("bd_video");
//隐藏默认的播放控件
myVideo.controls = false;
//获取播放按钮DOM模型
var playbutton = document.getElementById("playbutton");
//获取全屏按钮模型
var screen = document.getElementById("screen");
//获取进度条背景对象
var bd_bar = document.getElementById("bd1_progress");
//获取进度条对象
var bd_progress = document.getElementById("bd_progress");
document.getElementById("v_progress").style.width = "60px";

//控制视频播放或暂停
playbutton.onclick = function () {

    document.getElementById("v_progress").style.width = "80px";
    //打印视频总时长
    document.getElementById("etime").innerHTML = formatSeconds(myVideo.duration);
    if (myVideo.paused) {
        playbutton.style.backgroundImage = "url(images/pause.png)";

        myVideo.play();
    } else {
        //设置视频暂停的时间点
        playbutton.style.backgroundImage = "url(images/play.png)";
        myVideo.pause();
    }
};

//视频单双击实现播放暂停
myVideo.onclick = function () {
    //打印视频总时长
    document.getElementById("etime").innerHTML = formatSeconds(myVideo.duration);
    if (myVideo.paused) {
        playbutton.style.backgroundImage = "url(images/pause.png)";
        myVideo.play();
    } else {
        //设置视频暂停的时间点
        playbutton.style.backgroundImage = "url(images/play.png)";
        myVideo.pause();
    }
};

//播放时间监控
myVideo.addEventListener("timeupdate", function () {

    var currentTime = myVideo.currentTime;//获取当前播放时间
    var endtime = myVideo.duration;
    var progress = (currentTime / endtime) * 100;
    //打印进度条
    document.getElementById("bd_progress").style.width = progress + "%";
    //打印当前已播放时间
    document.getElementById("ctime").innerHTML = formatSeconds(currentTime);
    if (myVideo.ended) {
        document.getElementById("ctime").innerHTML = formatSeconds(0);
        document.getElementById("etime").innerHTML = formatSeconds(endtime);
        document.getElementById("bd_progress").style.width = 0;
        playbutton.style.backgroundImage = "url(images/play.png)";
    }

});

//拖放进度条

bd_bar.onclick = function (event) {
    myVideo.currentTime = ((event.clientX - 388) / 760) * myVideo.duration;
    document.getElementById("bd_progress").style.width = ((event.clientX - 388) / 760) + "%";

};


//音量监控


document.onmousewheel = function (e) {
    e = e || window.event;
    var wheelDelta = e.wheelDelta;

    if (wheelDelta > 0) {
        myVideo.volume += 0.1;
        document.getElementById("v_progress").style.width = (myVideo.volume / 1) * 100 + "px";
    } else {
        myVideo.volume -= 0.1;
        document.getElementById("v_progress").style.width = (myVideo.volume / 1) * 100 + "px";
    }
};




//秒转时间
function formatSeconds(value) {
    value = parseInt(value);
    var time;
    if (value > -1) {
        hour = Math.floor(value / 3600);
        min = Math.floor(value / 60) % 60;
        sec = value % 60;
        day = parseInt(hour / 24);
        if (day > 0) {
            hour = hour - 24 * day;
            time = day + "day " + hour + ":";
        } else
            time = hour + ":";
        if (min < 10) {
            time += "0";
        }
        time += min + ":";
        if (sec < 10) {
            time += "0";
        }
        time += sec;
    }
    return time;
}



//点击全屏按钮，全屏设置
screen.onclick = function () {
    if (invokeFieldOrMethod(document, 'FullScreen') || invokeFieldOrMethod(document, 'IsFullScreen') || document.IsFullScreen)
    {
        exitFullscreen();
    } else {
        launchFullscreen(myVideo);
    }
};



//双击全屏设置
myVideo.ondblclick = function () {
    if (invokeFieldOrMethod(document, 'FullScreen') || invokeFieldOrMethod(document, 'IsFullScreen') || document.IsFullScreen)
    {
        exitFullscreen();
    } else {
        launchFullscreen(myVideo);
    }
};

var invokeFieldOrMethod = function (myVideo, method)
{
    var usablePrefixMethod;
    ["webkit", "moz", "ms", "o", ""].forEach(function (prefix) {
        if (usablePrefixMethod)
            return;
        if (prefix === "") {
            // 无前缀，方法首字母小写
            method = method.slice(0, 1).toLowerCase() + method.slice(1);
        }
        var typePrefixMethod = typeof myVideo[prefix + method];
        if (typePrefixMethod + "" !== "undefined") {
            if (typePrefixMethod === "function") {
                usablePrefixMethod = myVideo[prefix + method]();
            } else {
                usablePrefixMethod = myVideo[prefix + method];
            }
        }
    });

    return usablePrefixMethod;
};
//全屏
function launchFullscreen(myVideo) {
    if (myVideo.requestFullscreen) {
        myVideo.requestFullscreen();
    } else if (myVideo.mozRequestFullScreen) {
        myVideo.mozRequestFullScreen();
    } else if (myVideo.msRequestFullscreen) {
        myVideo.msRequestFullscreen();
    } else if (myVideo.oRequestFullscreen) {
        myVideo.oRequestFullscreen();
    } else if (myVideo.webkitRequestFullscreen)
    {
        myVideo.webkitRequestFullScreen();
    } else {

        var docHtml = document.documentElement;
        var docBody = document.body;
        var videobox = document.getElementById('bd_player');
        var cssText = 'width:100%;height:100%;overflow:hidden;';
        docHtml.style.cssText = cssText;
        docBody.style.cssText = cssText;
        videobox.style.cssText = cssText + ';' + 'margin:0px;padding:0px;';
        document.IsFullScreen = true;
    }
}

//退出全屏
function exitFullscreen()
{
    if (document.exitFullscreen) {
        document.exitFullscreen();
    } else if (document.msExitFullscreen) {
        document.msExitFullscreen();
    } else if (document.mozCancelFullScreen) {
        document.mozCancelFullScreen();
    } else if (document.oRequestFullscreen) {
        document.oCancelFullScreen();
    } else if (document.webkitExitFullscreen) {
        document.webkitExitFullscreen();
    } else {
        var docHtml = document.documentElement;
        var docBody = document.body;
        var videobox = document.getElementById('bd_player');
        docHtml.style.cssText = "";
        docBody.style.cssText = "";
        videobox.style.cssText = "";
        document.IsFullScreen = false;
    }
}
